package net.dudesblog.guihelper.util.Language_util;

import java.io.File;
import java.io.FileInputStream;
import java.util.Locale;
import java.util.Properties;

public final class LanguageResource {

	private static Properties sProperties = new Properties();

	private static LanguageResource sLanguageResource;

	private static final Locale aDefaultLocale = new Locale("en");

	private static LanguageResource getInstance() {
		if (sLanguageResource == null) {
			sLanguageResource = new LanguageResource();
		}
		return sLanguageResource;
	}

	public static boolean isDefaultLanguage() {
		if (Language.getSCurrentLocaleLanguage().getLanguage() == aDefaultLocale
				.getLanguage()) {
			return true;
		}
		return false;

	}

	private LanguageResource() {
		super();
		try {
			loadProps();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void loadProps() throws Exception {
		File languageFile = new File("bin/"
				+ Language.getSCurrentLocaleLanguage().getLanguage() + ".xml");
		sProperties.loadFromXML(new FileInputStream(languageFile));

	}

	public static String getString(String pKey) {
		try {
			return getInstance().getProperties().getProperty(pKey);
		} catch (Exception e) {
			return "Somthing wrong in the translations";
		}
	}

	private Properties getProperties() {
		return sProperties;
	}

	public void setProperties(Properties pProperties) {
		sProperties = pProperties;
	}

}
