package net.dudesblog.rmc.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import net.dudesblog.guihelper.util.ErrorHandler;
import net.dudesblog.rmc.gui.MediaTable;

public class HelpAction extends AbstractConvertingAction implements
		ActionListener {

	private static final String OSName = System.getProperty("os.name")
			.toLowerCase();

	public HelpAction() {

	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		try {
			if (OSName.contains("mac")) {
				Runtime.getRuntime().exec("safari doc/index.html");
			} else if (OSName.contains("windows")) {
				Runtime.getRuntime().exec("explorer doc/index.html");
			} else {
				Runtime.getRuntime().exec("firefox doc/index.html");
			}
		} catch (IOException e) {
			ErrorHandler
					.handleError(
							e,
							"Error Launching default web browser",
							"<html>Error Launching default web browser,<br>you can still access documentation from :<br> {Real_Media_Converter_Home}/doc/index.html</html>",
							MediaTable.getInstance());
		}
	}

}
