package net.dudesblog.rmc.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;

import net.dudesblog.guihelper.util.Language_util.LanguageResource;
import net.dudesblog.rmc.gui.ItemPanel;
import net.dudesblog.rmc.gui.MediaTable;
import net.dudesblog.rmc.util.file_filters.rmFilter;

public class OpenFileAction implements ActionListener {

	private JFileChooser mFileChooser;

	private String mediaFolder;

	public OpenFileAction(String property) {
		mediaFolder = property;
	}

	@Override
	public void actionPerformed(ActionEvent pEvent) {
		mFileChooser = new JFileChooser(mediaFolder);
		mFileChooser.setFileFilter(new rmFilter());
		mFileChooser.setMultiSelectionEnabled(true);
		mFileChooser.setDialogTitle(LanguageResource
				.getString("CHOOSE_FILES_TO_CONVERT"));
		int returnVal = mFileChooser.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File[] aFiles = mFileChooser.getSelectedFiles();
			ItemPanel[] aItems = new ItemPanel[aFiles.length];
			for (int i = 0; i < aFiles.length; i++) {
				ItemPanel aItem = new ItemPanel(aFiles[i]);
				aItems[i] = aItem;
			}
			MediaTable.addFiles(aItems);
		}
	}

}
