package net.dudesblog.rmc.actions;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;

import net.dudesblog.guihelper.util.ErrorHandler;
import net.dudesblog.guihelper.util.Language_util.LanguageResource;
import net.dudesblog.rmc.core.JMPlayer;
import net.dudesblog.rmc.gui.ItemPanel;
import net.dudesblog.rmc.gui.MediaTable;

public class PlayerPreviousAction implements MouseListener {

	@Override
	public void mouseClicked(MouseEvent event) {
		final ItemPanel previousFile = MediaTable.getInstance()
				.getPreviousFileInList();
		MediaTable.getInstance().doFocus(previousFile.getLocation());
		if (previousFile != null && JMPlayer.getInstance().isPlaying()) {
			new Thread(new Runnable() {
				public void run() {
					try {
						File file;
						if (previousFile.isPathIsInvalid()) {
							file = previousFile.getAliasFile();
						} else {
							file = previousFile.getFile();
						}
						JMPlayer.getInstance().open(file);
					} catch (IOException e) {
						ErrorHandler.handleError(e, e.getCause().toString(),
								LanguageResource.getString("FILE_NOT_FOUND")
										+ previousFile, null);
					}
				}
			}).start();
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {

	}

	@Override
	public void mouseExited(MouseEvent e) {

	}

	@Override
	public void mousePressed(MouseEvent e) {

	}

	@Override
	public void mouseReleased(MouseEvent e) {

	}

}
