package net.dudesblog.rmc.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;

import net.dudesblog.guihelper.gui.reusables.LabledTextFeild;
import net.dudesblog.guihelper.util.Language_util.LanguageResource;

public class SelectDirAction implements ActionListener {

	private File dir;

	private String mediaFolder;

	private JFileChooser mFileChooser;

	private LabledTextFeild labledTextFeild;

	public SelectDirAction(LabledTextFeild labledTextFeild, String mediaFolder) {
		this.labledTextFeild = labledTextFeild;
		this.mediaFolder = mediaFolder;
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if (mediaFolder != null) {
			mFileChooser = new JFileChooser(mediaFolder);
		} else {
			mFileChooser = new JFileChooser();
		}
		mFileChooser.setMultiSelectionEnabled(false);
		mFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		mFileChooser.setDialogTitle(LanguageResource
				.getString("CHOOSE_DIR_TO_CONVERT"));
		int returnVal = mFileChooser.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			dir = mFileChooser.getSelectedFile();
			this.labledTextFeild.setValue(dir.getAbsolutePath());
		}
	}

	public File getDir() {
		return dir;
	}

	public void setDir(File dir) {
		this.dir = dir;
	}

}
