package net.dudesblog.rmc.util.constants;

import java.io.File;

public interface Constants {
	
	public static final String OSName = System.getProperty("os.name").toLowerCase();

	public interface GUIConstants {

		public static final String PARENT = "parent";

		public static final String SECOND_CHILD = "secondChild";

		public static final String FIRST_CHILD = "firstChild";
	}

	public class FileConstants {

		public static String USER_HOME;
		
		static {
			if (OSName.contains("windows")) {
				USER_HOME = "c:/rmc";
			} else {
				USER_HOME = System.getProperty("user.home");
			}
		}

		public static final String RMC_USER_FOLDER_NAME = ".rmc";

		public static final String RMC_TEMP_FOLDER_NAME = "tmp";

		public static final File RMC_USER_FOLDER = new File(USER_HOME, RMC_USER_FOLDER_NAME);

		public static final File RMC_TEMP_FOLDER = new File(RMC_USER_FOLDER, RMC_TEMP_FOLDER_NAME);

		public static final File RMC_USER_CONFIG_FILE = new File(RMC_USER_FOLDER, "userConfig.xml");

	}
}
